{$O-}
unit Unit1;

interface

uses
  TypInfo,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PaxProgram, PaxCompiler, StdCtrls, PaxBasicLanguage;

type
  TForm1 = class(TForm)
    Button1: TButton;
    PaxCompiler1: TPaxCompiler;
    PaxProgram1: TPaxProgram;
    PaxBasicLanguage1: TPaxBasicLanguage;
    PaxPascalLanguage1: TPaxPascalLanguage;
    procedure Button1Click(Sender: TObject);
    procedure PaxCompiler1UnknownDirective(Sender: TPaxCompiler;
      const Directive: string; var ok: Boolean);
    procedure PaxProgram1CreateObject(Sender: TPaxProgram; Instance: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  IMPORT_Common;

procedure TForm1.Button1Click(Sender: TObject);
begin
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxBasicLanguage1);
  PaxCompiler1.RegisterLanguage(PaxPascalLanguage1);
  PaxCompiler1.AddModule('1', 'Basic');
  PaxCompiler1.AddCodeFromFile('1', 'script.txt');
  if PaxCompiler1.Compile(PaxProgram1) then
  begin
    PaxProgram1.Run;
  end
  else
    ShowMessage(PaxCompiler1.ErrorMessage[0]);
end;

procedure TForm1.PaxCompiler1UnknownDirective(Sender: TPaxCompiler;
  const Directive: string; var ok: Boolean);
begin
  ok := true;
end;

procedure TForm1.PaxProgram1CreateObject(Sender: TPaxProgram;
  Instance: TObject);
var
  pti: PTypeInfo;
  ptd: PTypeData;
begin
  if Instance is TForm then
  begin
    pti := Instance.ClassInfo;
    ptd := GetTypeData(pti);
    Sender.LoadDFMFile(Instance, ptd^.UnitName + '.dfm');
  end;
end;

end.
