unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, PaxCompiler, PaxProgram, PaxJavaScriptLanguage;
type
  TForm1 = class(TForm)
    PaxCompiler1: TPaxCompiler;
    PaxProgram1: TPaxProgram;
    Button1: TButton;
    PaxJavaScriptLanguage1: TPaxJavaScriptLanguage;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  P: Pointer;
  I: Integer;
begin
 {$O-}
  PaxCompiler1.Reset;
  PaxCompiler1.RegisterLanguage(PaxJavaScriptLanguage1);

  PaxCompiler1.RegisterHeader(0, 'procedure ShowMessage(const Msg: string);', @ShowMessage);
  PaxCompiler1.RegisterHeader(0, 'function IntToStr(Value: Integer): string;', @IntToStr);

  PaxCompiler1.AddModule('1', PaxJavaScriptLanguage1.LanguageName);
  PaxCompiler1.AddCode('1', 'var x;');
  PaxCompiler1.AddCode('1', 'ShowMessage("script:" + IntToStr(x));');

  if PaxCompiler1.Compile(PaxProgram1) then
  begin
    P := PaxProgram1.GetAddress('x');
    Variant(P^) := 5; // change script-defind variable
    PaxProgram1.Run; // the first run
    ShowMessage('host:' + IntToStr(Variant(P^))); // show script-defined var
    Variant(P^) := 30; // change script-defind variable
    PaxProgram1.Run; // the second run
  end
  else
    for I:=0 to PaxCompiler1.ErrorCount do
      ShowMessage(PaxCompiler1.ErrorMessage[I]);
end;

initialization SetDump;

end.
